examples: bistromathic: when quitting, close the current line

When the user ctrl-d the line, we left the cursor not at col 0.
Let's fix that.
This revealed a few short-comings in the testing framework.

* examples/test (run): Also display the diffs.
And support -n.
* examples/c/bistromathic/bistromathic.test
* examples/c/bistromathic/parse.y
This commit is contained in:
Akim Demaille
2020-04-25 14:54:47 +02:00
parent 3b50adf7f4
commit c90110efd3
3 changed files with 45 additions and 26 deletions

View File

@@ -17,7 +17,7 @@
# macOS' version of readline does not repeat stdin on stdout in # macOS' version of readline does not repeat stdin on stdout in
# non-interactive mode. # non-interactive mode.
if ! echo '1-1' | prog | grep '1-1'; then if ! echo '1-1' | prog | grep '1-1' >/dev/null; then
strip_prompt=true strip_prompt=true
fi fi
@@ -65,26 +65,30 @@ cat >input <<EOF
* *
EOF EOF
run 0 '> * run 0 '> *
> err: 1.1: syntax error: expected end of file or - or ( or exit or number or function or variable before *' > ''
err: 1.1: syntax error: expected end of file or - or ( or exit or number or function or variable before *'
cat >input <<EOF cat >input <<EOF
1 + 2 * * 3 1 + 2 * * 3
EOF EOF
run 0 '> 1 + 2 * * 3 run 0 '> 1 + 2 * * 3
> err: 1.9: syntax error: expected - or ( or number or function or variable before *' > ''
err: 1.9: syntax error: expected - or ( or number or function or variable before *'
cat >input <<EOF
1 / 0
EOF
run 0 '> 1 / 0
> ''
err: 1.1-5: error: division by zero'
cat >input <<EOF cat >input <<EOF
100% 100%
EOF EOF
run 0 '> 100% run 0 '> 100%
100 100
> err: 1.4: error: invalid character' > ''
err: 1.4: error: invalid character'
cat >input <<EOF
1 / 0
EOF
run 0 '> 1 / 0
> err: 1.1-5: error: division by zero'
## ------------ ## ## ------------ ##
@@ -109,21 +113,24 @@ EOF
run 0 '> (1+ run 0 '> (1+
( - atan cos exp ln number sin sqrt ( - atan cos exp ln number sin sqrt
> (1+ > (1+
> err: 1.4: syntax error: expected - or ( or number or function or variable before end of file' > ''
err: 1.4: syntax error: expected - or ( or number or function or variable before end of file'
# Check the completion of a word. # Check the completion of a word.
sed -e 's/\\t/ /g' >input <<EOF sed -e 's/\\t/ /g' >input <<EOF
(at\t\t (at\t\t
EOF EOF
run 0 '> (atan ( '' run 0 '> (atan ( ''
> err: 1.9: syntax error: expected - or ( or number or function or variable before end of file' > ''
err: 1.9: syntax error: expected - or ( or number or function or variable before end of file'
# Check the completion at the very beginning. # Check the completion at the very beginning.
sed -e 's/\\t/ /g' >input <<EOF sed -e 's/\\t/ /g' >input <<EOF
e\t\t e\t\t
EOF EOF
run 0 '> e run -n 0 '> e
end of file exit exp '' end of file exit exp ''
> e > e
0 0
> err: ' > ''
err: '

View File

@@ -543,7 +543,11 @@ int main (int argc, char const* argv[])
{ {
char *line = readline ("> "); char *line = readline ("> ");
if (!line) if (!line)
return 0; {
// Finish the line started by the prompt.
putchar ('\n');
break;
}
if (*line) if (*line)
add_history (line); add_history (line);
process_line (&lloc, line); process_line (&lloc, line);

View File

@@ -68,15 +68,21 @@ trap cleanup 0 1 2 13 15
mkdir $$.dir mkdir $$.dir
cd $$.dir cd $$.dir
# run [-noerr] EXPECTED-EXIT-STATUS EXPECTED-OUTPUT [PARSER-OPTIONS] # run [-noerr, -n] EXPECTED-EXIT-STATUS EXPECTED-OUTPUT [PARSER-OPTIONS]
# ------------------------------------------------------------------ # ----------------------------------------------------------------------
# -noerr: ignore stderr, otherwise merge it into effective output. # -noerr: ignore stderr, otherwise merge it into effective output.
# -n: not final end-of-line in expected-output
run () run ()
{ {
noerr=false noerr=false
case $1 in echo=echo
(-noerr) noerr=true; shift;; while true; do
esac case $1 in
(-noerr) noerr=true; shift;;
(-n) echo=printf; shift;;
(*) break;;
esac
done
# Expected exit status. # Expected exit status.
sta_exp=$1 sta_exp=$1
@@ -84,9 +90,9 @@ run ()
# Expected output. # Expected output.
if $strip_prompt; then if $strip_prompt; then
out_exp=$(echo "$1" | sed -e 's/^> err:/err:/;/^> /d') $echo "$1" | sed -e '/^> /d' >exp
else else
out_exp=$1 $echo "$1" >exp
fi fi
shift shift
@@ -96,19 +102,21 @@ run ()
prog "$@" - <input >out_eff 2>err_eff || sta_eff=$? prog "$@" - <input >out_eff 2>err_eff || sta_eff=$?
# Combine effective output and error streams. # Combine effective output and error streams.
out_eff=$(cat out_eff && $noerr || sed -e 's/^/err: /g' err_eff) { cat out_eff && $noerr || sed -e 's/^/err: /g' err_eff; } >eff
if test $sta_eff -eq $sta_exp; then if test $sta_eff -eq $sta_exp; then
if test "$out_eff" = "$out_exp"; then if cmp eff exp 2>/dev/null; then
echo "$me: PASS: $number" echo "$me: PASS: $number"
else else
echo "$me: FAIL: $number" echo "$me: FAIL: $number"
echo "$me: input:" echo "$me: input:"
sed -e 's/^/ /' input sed -e 's/^/ /' input
echo "$me: expected output:" echo "$me: expected output:"
echo "$out_exp" | sed -e 's/^/ /' sed -e 's/^/ /' exp
echo "$me: effective output:" echo "$me: effective output:"
echo "$out_eff" | sed -e 's/^/ /' sed -e 's/^/ /' eff
echo "$me: diff:"
diff -u exp eff | sed -e 's/^/ /'
exit=false exit=false
fi fi
else else